

#ifndef LITERAL_INCLUDED
#define LITERAL_INCLUDED   1


#include "atom.h"


struct literal 
{

   bool positive;
   atom at;


   literal( bool positive, atom at ) 
      : positive( positive ),
        at( at ) 
   { }


   literal operator - ( ) const; 
      // Reverse polarity.

   bool operator == ( literal lit ) const;
   bool operator != ( literal lit ) const;

}; 


inline literal literal::operator - ( ) const
{
   return literal::literal( ! positive, at );
}


inline bool literal::operator == ( literal lit ) const
{
   return positive == lit. positive && 
          at == lit. at;
}


inline bool literal::operator != ( literal lit ) const
{
   return positive != lit. positive ||
          at != lit. at;
}


inline std::ostream& operator << ( std::ostream& stream, literal lit )
{
   if( lit. positive == false )
      std::cout << '-';
   std::cout << lit. at;
   return stream;
}


#endif



